; xMass Comet ver. 0.01 / 7. 2. 2021
; Copyright  (c) 2000, Pavel Kaspar
;
                NAME	Comet
MainVer         EQU     0            ; Cislo verze programu
SubVer          EQU     0            ; Podverze programu

PCON		EQU	087h	     ; Tato verze ASM51 nezna PCON

BR9600          EQU     0FDh

InvalTMP        EQU     03Fh         ; Konstanta pro neplatnou teplotu

; ****************************************************** Mapa pameti Procesoru

                DSEG

                ORG     0010h       ; RB0 - pracovni, RB1 - rezerva pro INT

; P1 - Ohon komety, P1.0 = prvni sloupec u Hlavy komety
; P3 - 0..4 Hlava komety, P3.0 = vnitrni LEDky, P3.4 = vnejsi LEDky
; P3.5 a P3.7 = Ohon komety, P3.7 = uplny konec Ohonu


TempH:          DS      1           ; Aktualni teplota v setinach stupnu v HEX
TempL:          DS      1           ; Teploty se lisi pro vytvoreni hystereze

FunkceRe1:      DS      1           ; Meni funkci Re1,tj. misto Topi na Chladi
FunkceRe2:      DS      1           ; Chlazeni misto vypnuti zapne a opacne


                ORG     0060h       ; Pocatek zasobniku
Stack:          DS      0020h       ; Max. hloubka vnoreni

                CSEG

                ORG     0000h
PowerOn:        CLR     A
                SJMP    On_Reset

                ORG     0003h
ExtInt0:	RETI

                ORG     000Bh
Timer0Int:      RETI

                ORG     0013h
ExtInt1:        RETI

                ORG     001Bh
Timer1Int:      RETI

                ORG     0023h
SerialInt:      RETI

                ORG     002Bh
Timer2Int:      RETI


                ORG     0030h

On_Reset:       MOV	SP, #(Stack-1)	; Inicializace zasobniku
                MOV     PSW, A          ; Banka 0, v A je 0
                MOV     SCON, #01010011b; Mod 1; 1 start,8 datovych,1 stop bit
		MOV	TMOD, #00100001b; C/T0 - mod 1, casovac 16 bitu
					; C/T1 - mod 2, casovac pro Serial
                MOV     TH1, #BR9600    ; Prenosova rychlost
                MOV     TL1, #BR9600
                MOV     PCON, #00000000b; Nasobitel SMOD = 0
		MOV	TCON, #01010101b; C/T0,1 povolen; EI0,1 reag. na hranu
                SETB    TI              ; Pro vyslani 1. znaku, jinak DeadLock
                CLR     RI              ;
		MOV	IE, #00000010b	; Disable, pripraveno pro T0
		MOV	IP, #00000000b  ; vse nizkou prioritu

                ACALL   InitLED         ; Inicializace = ClrLED

                MOV     P1, #0FFh       ; Rozsvit vsechny LED 	
                MOV     P3, #0FFh
                ACALL   Cekej1s         ; Cekej
; -------------------------------------------------------------- Hlavni smycka
Main:
                MOV     P1, #00h        ; Zhasni vsechny LED 	
                MOV     P3, #00h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #01h 	
                MOV     P3, #01h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #02h 	
                MOV     P3, #02h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #04h 	
                MOV     P3, #04h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #08h 	
                MOV     P3, #08h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #010h	
                MOV     P3, #010h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #020h	
                MOV     P3, #00h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #040h	
                MOV     P3, #01h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #080h	
                MOV     P3, #02h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #000h	
                MOV     P3, #024h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #000h	
                MOV     P3, #088h
                ACALL   Cekej1s         ; Cekej

                MOV     P1, #000h	
                MOV     P3, #010h
                ACALL   Cekej1s         ; Cekej

                SJMP    Main

; ****************************************************************************


; ***************************************************************  Obsluha LED

InitLED:                                ; Inicializace LED Displaye
                CLR     A
                MOV     P1, #00h
                MOV     P3, #00h
                RET

; ********************************************************************  Cekani

A10Wait:                                ; Ceka A * 10 uS
                NOP
                NOP
                NOP
                NOP
                NOP
                NOP
                NOP
                DJNZ    Acc, A10Wait
                RET

Wait40:                                 ; Ceka cca 40 mikrosekund
                PUSH    Acc
                MOV     A, #14
                DJNZ    Acc, $
                POP     Acc
                RET

DelayA:                                 ; Ceka A * Delay = A milisekund
                ACALL   Delay
                DJNZ    Acc, DelayA
                RET

Delay:				        ; Ceka asi 1 ms / 11.0592 MHz
		PUSH	PSW             ; Celkem 921 vcetne CALL a RET
                PUSH    Acc             ;   7 + 227 * 4 + 6
		MOV	A, #227
DelayLoop:	NOP
		NOP
		DJNZ	Acc, DelayLoop
		POP	Acc
		POP	PSW
		RET

Cekej1s:                              	; Ceka asi 1,2 sekundy
                CLR     A
                ACALL   DelayA          ; Pomocne cekani
                ACALL   DelayA
                ACALL   DelayA
                ACALL   DelayA
                RET


; *****************************************************************  Konstanty

KonecStr:       DB      'Konec programu', 0

                END
